#include<bits/stdc++.h>
using namespace std;

int T;
int broj_ucenika,broj_veza;
int broj_sputala;
bool sputan[100005];
vector<int> povezanost[100005];

int razdaljina[100005];
bool posecen[100005];
int prethodni[100005];

int pocetniCvor,najudaljenijiUcenik;

void fenvik(int cvor){
    posecen[cvor]=true;
    if(sputan[cvor]) return;
    for(int i=0,trcvor;i<povezanost[cvor].size();++i){
        trcvor=povezanost[cvor][i];
        if(!posecen[trcvor]){
            if(razdaljina[trcvor]>razdaljina[cvor]+1){
                razdaljina[trcvor]=razdaljina[cvor]+1;
                if(razdaljina[trcvor]>razdaljina[najudaljenijiUcenik])
                    najudaljenijiUcenik=trcvor;
                prethodni[trcvor]=cvor;
            }
            fenvik(trcvor);
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    scanf("%d",&T);
    while(T--){
        scanf("%d%d%d",&broj_ucenika,&broj_veza,&broj_sputala);
        memset(sputan,0,sizeof(bool)*broj_ucenika);
        for(int i=1,id_sputanog;i<=broj_sputala;++i){
            scanf("%d",&id_sputanog);
            sputan[id_sputanog]=true;
        }
        for(int i=1,prvi,drugi;i<=broj_veza;++i){
            scanf("%d%d",&prvi,&drugi);
            povezanost[prvi].push_back(drugi);
            povezanost[drugi].push_back(prvi);
        }

        pocetniCvor=1;
        while(sputan[pocetniCvor]) ++pocetniCvor;
        for(int i=1;i<=broj_ucenika;++i){
            razdaljina[i]=INT_MAX;
            prethodni[i]=0;
        }
        razdaljina[pocetniCvor]=0;
        prethodni[pocetniCvor]=-1;
        najudaljenijiUcenik=pocetniCvor;

        memset(posecen,0,sizeof(bool)*broj_ucenika);
        fenvik(pocetniCvor);

        int moguce=true;
        for(int i=1;i<=broj_ucenika;++i)
            if(!posecen[i]){
                printf("-1\n");
                moguce=false;
                break;
            }
        if(!moguce) continue;

        printf("%d\n",broj_ucenika-1);
        for(int i=1;i<=broj_ucenika;++i)
            if(prethodni[i]!=-1) printf("%d %d\n",i,prethodni[i]);
    }
    return 0;
}